# acl -- one advanced C/C++ lib for UNIX and WINDOWS

<!-- vim-markdown-toc GFM -->
* [Description](#description)
* [Features](#features)
* [Reference](#reference)
* [License](#license)
* [Contact](#contact)

<!-- vim-markdown-toc -->
## Description
Advanced C/C++ library(ACL) for UNIX-like OS and WIN32 OS, including sync/async/ssl iostream for net/file, thread pool, process pool, db pool, server framework, event, memory, string, array/hash/ring/list, xml and json parser, http/smtp/icmp/redis/memcache/handler-sockett protocol, SSL/TLS, C unit test, etc

## Features
* data structure: array/htable/ring/stack/avl
* stream(sync and async) for socket and file
* thread pool and process pool
* **redis**/memcached/beanstalkd/handler-socket client
* mysql/sqlite connection pool
* http/icmp/smtp protocol
* json/xml/mime/base64/qp/uucode
* event(select, poll, iocp, epoll, kqueue, devpoll, win32 message)
* **server framework(multi-process, multi-threads, aio, trigger, udp)**
* **HttpServlet for C++; http client and http server**
* session manager
* log/configure
* file queue
* zlib/iconv wrapper
* unit test framework

## Reference
- In Chinese: [README.md](README.md)
- Samples: [SAMPLES.md](SAMPLES.md)

## License
- LGPL-v3 license (see LICENSE.txt in the acl project)

## Contact
- Website: http://www.iteye.com
- Download: https://sourceforge.net/projects/acl
- QQ group: 242722074
