#pragma once
#include <stddef.h>
#include "fiber_cpp_define.hpp"

struct ACL_FIBER;

namespace acl {

typedef enum 
{
	FIBER_EVENT_T_KERNEL,  // Linux: epoll, FreeBSD: kquque, Windows: iocp
	FIBER_EVENT_T_POLL,
	FIBER_EVENT_T_SELECT,
	FIBER_EVENT_T_WMSG,
} fiber_event_t;

/**
 * Эඨ壬࣬Ҫ̳вʵִ鷽
 */
class FIBER_CPP_API fiber
{
public:
	/**
	 * 캯
	 * @param running {bool} Ϊ true ʱʾǰЭ
	 *  һЭ̶ѣԱ ACL_FIBER 󶨣ʱֹñ
	 *   start Э; Ϊ false ʱҪ start 
	 *  Э
	 */
	fiber(bool running = false);
	virtual ~fiber(void);

	/**
	 * ڴһЭҹ running Ϊ false ʱҪ
	 * Э̣Ȼص run ص running Ϊ true ʱ
	 * ֹ start 
	 * @param stack_size {size_t} Э̶ջС
	 */
	void start(size_t stack_size = 320000);

	/**
	 * ڱЭʱô˺֪ͨЭ˳
	 * @return {bool}  false ʾЭδѾ˳
	 */
	bool kill(void);

	/**
	 * жϵǰЭǷ֪ͨ˳
	 * @return {bool} ЭǷ֪ͨ˳
	 */
	bool killed(void) const;

	/**
	 * жϵǰеЭǷ֪ͨ˳÷ killed Ϊ
	 * killed ȱ acl::fiber УҸЭ̶пУ
	 * Ҳпܱ𣬶 self_killed Ҫ acl::fiber һʾ
	 * ǰеЭ
	 * @return {bool}
	 */
	static bool self_killed(void);

	/**
	 * ñЭ̶ ID 
	 * @return {unsigned int}
	 */
	unsigned int get_id(void) const;

	/**
	 * õǰеЭ̶ ID 
	 * @return {unsigned int}
	 */
	static unsigned int self(void);

	/**
	 * õǰЭִĳϵͳ API ʱĴ
	 * return {int}
	 */
	int get_errno(void) const;

	/**
	 * õǰЭ̵Ĵ
	 * @param errnum {int}
	 */
	void set_errno(int errnum);

	/**
	 * ñβĳϢ
	 * @return {const char*}
	 */
	static const char* last_serror(void);

	/**
	 * ñβĳ
	 * @return {int}
	 */
	static int last_error(void);

	/**
	 * תϢ
	 * @param errnum {int} 
	 * @param buf {char*} 洢
	 * @param size {size_t} buf ռС
	 * @return {const char*} buf ַ
	 */
	static const char* strerror(int errnum, char* buf, size_t size);

	/**
	 * Ϣ׼
	 * @param on {bool} Ϊ true ʱڲϢ׼
	 */
	static void stdout_open(bool on);

	/**
	 * ʽЭ̵¼ͣͬʱЭ̵ΪģʽЭ̺󲻱
	 * ʽ schedule  schedule_with Э̵
	 * @param type {fiber_event_t} ¼ͣμFIBER_EVENT_T_XXX
	 * @param schedule_auto {bool} Ϊ true򴴽Э̶иЭ
	 *  󲻱ʽ schedule/schedule_with еЭ̹̣ڲ
	 *  ԶЭ̵ڴЭ̺󣬱ʽص schedule 
	 *  schedule_with ʽЭ̵Э̹̣ڲȱʡ״̬Ϊ false
	 */
	static void init(fiber_event_t type, bool schedule_auto = false);

	/**
	 * Эеĵȹ
	 */
	static void schedule(void);

	/**
	 * Э̵ʱָ¼ͣñͬʱ schedule_init
	 *  schedule 
	 * @param type {fiber_event_t} ¼ͣμFIBER_EVENT_T_XXX
	 */
	static void schedule_with(fiber_event_t type);

	/**
	 * жϵǰ߳ǷЭ̵״̬
	 * @return {bool}
	 */
	static bool scheduled(void);

	/**
	 *  ֹͣЭ̵ȹ
	 */
	static void schedule_stop(void);

public:
	/**
	 * ǰеЭ(Э) 
	 */
	static void yield(void);

	/**
	 * ǰЭִ̣еȴеһЭ
	 */
	static void switch_to_next(void);

	/**
	 * ָЭ̶ж
	 * @param f {fiber&}
	 */
	static void ready(fiber& f);

	/**
	 * ʹǰеЭָ
	 * @param milliseconds {unsigned int} ָҪߵĺ
	 * @return {unsigned int} ЭߺٴαѺʣĺ
	 */
	static unsigned int delay(unsigned int milliseconds);

	/**
	 * ôڴ״̬Э
	 * @return {unsigned}
	 */
	static unsigned alive_number(void);

	/**
	 * ô˳״̬Э̶
	 * @return {unsigned}
	 */
	static unsigned dead_number(void);

	/**
	 * ߳ô˺õǰ߳ǷҪ hook ϵͳ APIڲȱʡ
	 *  hook ϵͳ API
	 * @param on {bool}
	 */
	static void hook_api(bool on);

	/**
	 * ʽñʹ acl  IO Э̻ UNIX ƽ̨²ʽ
	 * ΪڲԶ HOOK IO API
	 */
	static void acl_io_hook(void);

	/**
	 * ñȡ aclе IO Э̻
	 */
	static void acl_io_unlock(void);

	/**
	 * õǰϵͳ
	 * @return {int}
	 */
	static int  get_sys_errno(void);

	/**
	 * õǰϵͳ
	 * @param errnum {int}
	 */
	static void set_sys_errno(int errnum);

public:
	/**
	 * رЭ̶Ӧ C ԵЭ̶
	 * @return {ACL_FIBER* }
	 */
	ACL_FIBER* get_fiber(void) const;

protected:
	/**
	 * 麯ʵֱͨ start Э̺󣬱
	 * 麯ᱻãӶ֪ͨЭ; ڹ캯еĲ
	 * running Ϊ true  start ֹãʱ鷽Ҳᱻ
	 */
	virtual void run(void);

private:
	ACL_FIBER* f_;

	static void fiber_callback(ACL_FIBER* f, void* ctx);
};

/**
 * ʱЭ
 */
class FIBER_CPP_API fiber_timer
{
public:
	fiber_timer(void);
	virtual ~fiber_timer(void) {}

	/**
	 * һЭ̶ʱ
	 * @param milliseconds {unsigned int} 뼶ʱ
	 * @param stack_size {size_t} Э̵ջռС
	 */
	void start(unsigned int milliseconds, size_t stack_size = 320000);

protected:
	/**
	 * ʵָô鷽ʱʱص÷
	 */
	virtual void run(void) = 0;

private:
	ACL_FIBER* f_;

	static void timer_callback(ACL_FIBER* f, void* ctx);
};

/**
 * ʱЭ
 */
template <typename T>
class fiber_trigger : public fiber
{
public:
	fiber_trigger(timer_trigger<T>& timer)
	: delay_(100)
	, stop_(false)
	, timer_(timer)
	{
	}

	virtual ~fiber_trigger(void) {}

	void add(T* o)
	{
		mbox_.push(o);
	}

	void del(T* o)
	{
		timer_.del(o);
	}

	timer_trigger<T>& get_trigger(void)
	{
		return timer_;
	}

	// @override
	void run(void)
	{
		while (!stop_) {
			T* o = mbox_.pop(delay_);
			if (o)
				timer_.add(o);

			long long next = timer_.trigger();
			long long curr = get_curr_stamp();
			if (next == -1)
				delay_ = 100;
			else {
				delay_ = next - curr;
				if (delay_ <= 0)
					delay_ = 1;
			}
		}
	}

private:
	long long delay_;
	bool stop_;

	timer_trigger<T>& timer_;
	mbox<T> mbox_;
};

} // namespace acl

#if defined(__GNUC__) && (__GNUC__ > 6 ||(__GNUC__ == 6 && __GNUC_MINOR__ >= 0))
# ifndef   ACL_USE_CPP11
#  define  ACL_USE_CPP11
# endif
#endif

#ifdef	ACL_USE_CPP11

#include <functional>

namespace acl
{

class FIBER_CPP_API go_fiber
{
public:
	go_fiber(void) {}
	go_fiber(size_t stack_size) : stack_size_(stack_size) {}

	void operator=(std::function<void()> fn);

private:
	size_t stack_size_ = 320000;
};

} // namespace acl

#define	go		acl::go_fiber()=
#define	go_stack(size)	acl::go_fiber(size)=

/**
 * static void fiber1(void)
 * {
 * 	printf("fiber: %d\r\n", acl::fiber::self());
 * }
 *
 * static void fiber2(acl::string& buf)
 * {
 * 	printf("in fiber: %d, buf: %s\r\n", acl::fiber::self(), buf.c_str());
 * 	buf = "world";
 * }
 *
 * static void fiber3(const acl::string& buf)
 * {
 * 	printf("in fiber: %d, buf: %s\r\n", acl::fiber::self(), buf.c_str());
 * }
 *
 * static test(void)
 * {
 * 	go fiber1;
 * 	
 * 	acl::string buf("hello");
 *
 * 	go[&] {
 * 		fiber2(buf);
 * 	};
 * 	
 * 	go[=] {
 * 		fiber3(buf);
 * 	};
 * 
 * 	go[&] {
 * 		fiber3(buf);
 * 	};
 * }
 */
#endif
